
'**********************************************************************
'File Name:              test_sxlcd.bas
'Dev:                    Daniele De Santis
'Email:                  desantis@areasx.com
'Web:                    http://www.areasx.com
'
'Versione:               0.0
'Data:                   18/03/11
'Note Hardware:          BX24 su SX18. 
'Note Software: 
'**********************************************************************
'Parametri porta Seriale
Const PortNumber As Byte = 3
Const BaudRate As Long = 9600
Const TxPin As Byte = 5
Const RxPin As Byte = 6  'Expander JP3

'LED Debug
Const LED_ROSSO As Byte = 25
Const LED_VERDE As Byte = 26

Public Const OutputBufferSize  As integer = 10
Public Const InputBufferSize   As integer = 23
Public InputBuffer(1 To InputBufferSize)  As Byte
Public OuputBuffer(1 To OutputBufferSize) As Byte

'APERTURA DELLA PORTA COM
Public Sub OpenSeriale()
    Call OpenQueue(InputBuffer, InputBufferSize)
    Call OpenQueue(OuputBuffer, OutputBufferSize)
    Call DefineCom3(RxPin, TxPin, bx0000_1000) 'Setta la seriale come inverted, no parity, 8 bits.    
    Call OpenCom(PortNumber, BaudRate, InputBuffer, OuputBuffer)
End Sub

'FUNZIONE PER RICEVERE UN BYTE
Public Sub GetByte(ByRef Value As Byte, ByRef Success As Boolean)
    Success = StatusQueue(InputBuffer)
    If (Success) Then
      Call GetQueue(InputBuffer, Value, 1)
    Else
      Value = 0
    End If
End Sub

'FUNZIONE PER RICEVERE UNA STRINGA
Public Function GetStr(ByVal BufferSize As Integer,ByVal DelayRead As Single) As String
    Dim Key As Byte
    Dim Success As Boolean
    Dim I As Integer
    Dim Value As String
    Call Delay(DelayRead)
    Value=""
    For I = 1 To BufferSize
      Call GetByte(Key, Success)
      If(Success) then
       Value=Value & chr(Key)
      End If
    Next  
    GetStr = Value
End Function


Public Function HEX2INT (ByVal HexStr As String) As Long
  Dim i As Integer
  Dim r As Long
  Dim S As Single
  Dim B As Boolean
  
  r=0
  For i=Len(HexStr) to 1 step -1
    If(Mid(HexStr,i,1)="A") Then
      S=10.0
    ElseIf(Mid(HexStr,i,1)="B") Then
      S=11.0
    ElseIf(Mid(HexStr,i,1)="C") Then
      S=12.0
    ElseIf(Mid(HexStr,i,1)="D") Then
      S=13.0
    ElseIf(Mid(HexStr,i,1)="E") Then
      S=14.0
    ElseIf(Mid(HexStr,i,1)="F") Then
      S=15.0
    Else
      Call ValueS(Mid(HexStr,i,1),S, B)
      'v=Cint(S)
    End If 
    r = r + Clng((Clng(S) * Clng(CSng(2) ^ (4 * (Len(HexStr)-i)))))
  Next 
  HEX2INT = r
End Function

'-------------------------------------
'
'  INIZIO PROGRAMMA
'
'-------------------------------------
Public Sub Main()
  Dim buff As string
  Dim i As Byte
  dim CRC_C As byte
  dim CRC_T As byte
  'INIT SYSTEM
  Call Delay(0.5)
  Call PutPin(LED_ROSSO, 0) 'LED ON
  Call PutPin(LED_VERDE, 0)
  Call Delay(0.5) 
  Debug.Print "--------------------------"
  Debug.Print "Test RFID"
  Debug.Print "v 1.0.0"
  Debug.Print "dev DeSantix.iT"
  Debug.Print "--------------------------" 
  Call PutPin(LED_ROSSO, 1) 'LED OFF
  Call PutPin(LED_VERDE, 1)
  Call OpenSeriale()
  'MAIN LOOP
  Do
    buff = GetStr(InputBufferSize, 0.5)
    If(Len(buff)>0) Then
      If(Asc(Mid(buff,1,1))=2) then 
        Debug.Print "***********************************"
        CRC_T=cbyte(HEX2INT(Mid(buff,12,2)))
        debug.print "CRC Tag       ->" & cstr(CRC_T)
        CRC_C =0
        CRC_C = cbyte(HEX2INT(Mid(buff,2,2))) xor cbyte(HEX2INT(Mid(buff,4,2))) xor  cbyte(HEX2INT(Mid(buff,6,2))) xor  cbyte(HEX2INT(Mid(buff,8,2))) xor  cbyte(HEX2INT(Mid(buff,10,2)))
        debug.print "CRC Calcolato ->" & cstr(CRC_C)
        if(CRC_C=CRC_T) Then
          debug.print "Valore Tag  ->" & Mid(buff,2,12)
          debug.print "Numero Tag  ->" & Cstr(HEX2INT(Mid(buff,4,8)))
          Call PutPin(LED_VERDE, 0)
          Call Delay(0.1)
          Call PutPin(LED_VERDE, 1)
        Else
          debug.print "ERRORE CRC"
          Call PutPin(LED_ROSSO, 0)
          Call Delay(0.1)
          Call PutPin(LED_ROSSO, 1)
        End If
      End If
    End If
  Loop
End Sub
